import {
  selectProjectAuditinfoList
} from '../../../api/publics'
import {
  getProjectFunVerify,
  delProjectFunVerify
} from '../../../api/projectFunVerify'

const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    id: "",
    infoData: {},
    imageList: [],
    minImageList: [],
    loginName: "",
    showDel: true,
    activeName: "",
    flowRecordList: [],
    request: app.globalData.reqUrl,
    flowNodes: [{
      text: '开始'
    }, {
      text: '提交申请'
    }, {
      text: '监理审批'
    }, {
      text: '结束'
    }],
    active: 100,
    checkFiles:[]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let {
      id
    } = options
    //获取缓存数据
    wx.getStorage({
      key: 'userinfo',
      success: res => {
        this.setData({
          id,
          loginName: res.data.loginName
        })
        this.getInfo();
        this.getAuditinfo();
      }
    })
  },

  /**
   * 获取安全检查详情信息
   * 
   */
  getInfo() {
    getProjectFunVerify(this.data.id).then(res =>{
      if(res.code==200){
        let state = this.data.active;
        if (res.data.approveStatus == "1") {
          state = 2;
        } else if (res.data.approveStatus == "3") {
          state = 1;
        }
        this.setData({
          active: state
        })
        let urls = [];
        let minUrls = [];
        let checkFiles = [];
        if (res.data.imageUrls) {
          res.data.imageUrls.split(',').forEach(element => {
            urls.push(this.data.request + element);
            minUrls.push(this.data.request + element + '.min.jpg');
          });
        }
        if(res.data.checkFiles){
          res.data.checkFiles.split(",").forEach(item =>{
              let it = item.split('/');
              checkFiles.push({'name':it[it.length-1],path:item});
            });
        }
        this.setData({
          infoData: res.data,
          imageList: urls,
          minImageList: minUrls,
          checkFiles,
        })
        //判断当前能否删除
        if (res.data.createBy == this.data.loginName && res.data.approveStatus != "4") {
          this.setData({
            showDel: true
          })
        }
      }
  });
  },

  onDelete() {
    //弹出确认
    let that = this
    wx.showModal({
      title: '提示',
      content: '是否确定删除此条数据？',
      success: function (sm) {
        if (sm.confirm) {
          // 用户点击了确定 可以调用了
          that.deleteData();
        } else if (sm.cancel) {
          console.log('用户点击取消');
        }
      }
    })
  },
  
  deleteData() {
    delProjectFunVerify(this.data.id).then(res =>{
      app.toast("删除成功！")
      wx.navigateTo({
        url: `../list/index`,
      })
    });
  },

  //跳转修改页面
  onUpdate: function () {
    let id = this.data.id;
    wx.redirectTo({
      url: `../edit/index?id=${id}`,
    })
  },

  /**
   * 查询流程日志
   */
  getAuditinfo() {
    let params = {
      fromType: "5",
      fromId: this.data.id
    }
    selectProjectAuditinfoList(params).then(res =>{
      if (res.code == 200) {
        this.setData({
          flowRecordList: res.data
        })
      }
    });
  },

  // 手风琴
  onChange(event) {
    this.setData({
      activeName: event.detail,
    });
  },

  //展示图片
  showImg: function (e) {
    var that = this;
    wx.previewImage({
      urls: that.data.imageList,
      current: that.data.imageList[e.currentTarget.dataset.index]
    })
  },

  returnToPage: function () {
    /*关闭当前页面，跳转到应用内的某个页面。但是不允许跳转到 tabbar 页面*/
    wx.navigateTo({
      url: '../list/index',
    })
  },

  /**
   * 下载附件
   * @param {*} e 
   */
  downFile: function (e) {
    let {
      path,
    } = e.currentTarget.dataset.set
    wx.downloadFile({
      url: app.globalData.uploadUrl + '/common/download/resource?resource=' + path,
      success: function (res) {
        const filePath = res.tempFilePath
        wx.openDocument({
          filePath: filePath,
          success: function (res) {
            console.log('打开文档成功')
          },
          fail: function (res) {
            console.log(res)
          }
        })
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})